# layout of boot.img

### 1. header part

              item                        size in bytes
    +----------------------------------------------------------+
    |<MAGIC HEADER>                  |     8                   |
    |--------------------------------+-------------------------|
    |<kernel length>                 |     4                   |
    |--------------------------------+-------------------------|
    |<kernel offset>                 |     4                   |
    |--------------------------------+-------------------------|
    |<ramdisk length>                |     4                   |
    |--------------------------------+-------------------------|
    |<ramdisk offset>                |     4                   |
    |--------------------------------+-------------------------|
    |<second bootloader length>      |     4                   |
    |--------------------------------+-------------------------|
    |<second bootloader offset>      |     4                   |
    |--------------------------------+-------------------------|
    |<tags offset>                   |     4                   |
    |--------------------------------+-------------------------|
    |<page size>                     |     4                   |
    |--------------------------------+-------------------------|
    | RESERVED                       |     4                   |
    |--------------------------------+-------------------------|
    |<os version& os patch level>    |     4                   |
    |--------------------------------+-------------------------|
    |<board name>                    |     16                  |
    |--------------------------------+-------------------------|
    |<cmdline part 1>                |     512                 |
    |--------------------------------+-------------------------|
    |<hash digest>                   |     32                  |
    |--------------------------------+-------------------------|
    |<cmdline part 2>                |     1024                |
    |--------------------------------+-------------------------|
    |<padding>                       | min(n * page_zie - 1632)|
    +----------------------------------------------------------+
    
### 2. data part

    +----------------------------------------------------------+
    |<kernel>                        |   kernel length         |
    |--------------------------------+-------------------------|
    |<padding>                       |                         |
    +----------------------------------------------------------+
    
    +--------------------------------+-------------------------+
    |<ramdisk>                       |   ramdisk length        |
    |--------------------------------+-------------------------|
    |<padding>                       |                         |
    +----------------------------------------------------------+
    
    +--------------------------------+-------------------------+
    |<second bootloader>             | second bootloader length|
    |--------------------------------+-------------------------|
    |<padding>                       |                         |
    +----------------------------------------------------------+
